﻿//////////////////////////////////////////////////
//               Movement.cs                    //
//         Part of RebornCo by kaihaider        //
//////////////////////////////////////////////////

using System;
using System.Runtime.Remoting.Messaging;
using Buddy.Coroutines;
using Clio.Utilities;
using ff14bot;
using ff14bot.Enums;
using ff14bot.Helpers;
using ff14bot.Managers;
using ff14bot.Objects;
using System.Threading.Tasks;
using System.Windows.Media;
using ff14bot.Navigation;
using Clio.Common;
namespace RebornCo.Helpers
{
    internal static class Movement
    {
        //npc interact 7f

        //Core.Me.CombatReach 0.5f 
        //Melee Spell 3f
        //actual range is Mine + Theirs + Spell
        public static Clio.Utilities.Vector3 OldTargetLocation;
        public static Clio.Utilities.Vector3 MyOldLocation;
        public static int RunningCounter;
        public static bool Running;
        #region Range
        public static float MeleeRange
        {
            get
            {
                return Core.Me.CombatReach + 3f + Core.Me.CurrentTarget.CombatReach;
            }
        }
        public static float ObjectMeleeRange(GameObject o)
        {
            return Core.Me.CombatReach + 3f + o.CombatReach;
            
        }
        public static float CombatMovementRange(GameObject o)
        {
            return o == null ? 0 : Math.Max(ObjectMeleeRange(o) - 1f, 3.4f);
        }

        public static float MovementRange
        {
            get
            {
                return System.Math.Max(MeleeRange - 0.5f, 3.4f);
            }
        }
        public static bool IsInSafeRange(GameObject o)
        {
            if (o == null) return false;
            return o.Distance() < CombatMovementRange(o);
        }
        public static bool TooClose(GameObject o)
        {
            if (o == null) return false;
            return o.Distance() < 1f;
        }
#endregion
        #region Face
        public static async Task<bool> CheckFace(GameObject o)
        {//&& !Helpers.Rogue.me.MovementInfo.IsStrafing
            if (RebornCoRoutine.WindowSettings.Movement && o != null
                && (MovementManager.IsMoving && !TooClose(o) && (IsInSafeRange(o) || !IsFacingMovement(Core.Me, o) &&  o.InLineOfSight())
                    || !MovementManager.IsMoving && !IsFacing(Core.Me, o)) 
                ) await Coroutine.ExternalTask(Task.Run<bool>(() => Face(o)));
            return false;
        }
        public static bool Face(GameObject o)
        {
            StopMove();
            o.Face();
            return false;
        }
        public static bool IsFacingMovement(GameObject face, GameObject location)
        {
            if (face == null || location == null) return false;
            float rotationToLocation = MathEx.NormalizeRadian(MathHelper.CalculateHeading(face.Location, location.Location) + (float)Math.PI);
            float d = Math.Abs(MathEx.NormalizeRadian(face.Heading - rotationToLocation));
            if (d > Math.PI) d = Math.Abs(d - 2 * (float)Math.PI);
            //Logging.Write("Differance: " + d);
            return d < 0.12;
        }
        public static bool IsFacing(GameObject face,GameObject location)
        {
            if (face == null||location ==null) return false;
            float rotationToLocation = MathEx.NormalizeRadian(MathHelper.CalculateHeading(face.Location, location.Location) + (float)Math.PI);
            float d = Math.Abs(MathEx.NormalizeRadian(face.Heading - rotationToLocation));
            if (d > Math.PI) d = Math.Abs(d - 2 * (float)Math.PI);
            //Logging.Write("Differance: " + d);
            return d < 0.785f;
        }
        #endregion
        #region Move


        public static void CheckStuckRunning()
        {
            if (RebornCoRoutine.WindowSettings.Movement && RebornCoRoutine.WindowSettings.MeshFreeMovement) //none mesh setting
            {
                if (Running && Core.Me.CurrentTarget != null && !IsInSafeRange(Core.Me.CurrentTarget) && RunningCounter > 400000)
                {
                    //write anti stuck by heading and running into oblivion in different directions.
                }

                if (Running && Core.Me.CurrentTarget != null && IsInSafeRange(Core.Me.CurrentTarget)
                    && Core.Me.CurrentTarget.InLineOfSight())
                {
                    Running = false;
                    RunningCounter = 0;
                }
                else if ((Running && !Core.Me.InCombat && Core.Me.Location.Distance(MyOldLocation) < 2 || !Running)
                    && RunningCounter < 2000000 && MovementManager.IsMoving && Core.Me.CurrentTarget != null
                    && !(IsInSafeRange(Core.Me.CurrentTarget)
                    ))
                    RunningCounter++;
                else if (Core.Me.Distance(MyOldLocation) > 2)
                {
                    MyOldLocation = Core.Me.Location;
                    RunningCounter = 0;
                }
                else if (!Running && RunningCounter > 40)
                {
                    Logging.Write(Colors.SkyBlue, "[RebornCo] Movement problem detected, switching to mesh.");
                    Running = true;
                    StopMove();
                }
            }
        }
        public static bool StopMove()
        {

            if (MovementManager.IsMoving && RebornCoRoutine.WindowSettings.Movement)
            {
                Logging.Write(Colors.OrangeRed, "[RebornCo] Stop Moving");  
                Navigator.PlayerMover.MoveStop();
            }
            return false;
        }
        //Core.Me.Distance(Core.Me.CurrentTarget.Location) < Core.Me.Distance(Movement.OldTargetLocation) && !MovementManager.IsMoving 
        public static async Task<bool> MoveToTarget()
        {
            if (Core.Me.IsCasting || Core.Me.CurrentTarget == null || !RebornCoRoutine.WindowSettings.Movement || Core.Me.IsMounted) return false;
            await CheckFace(Core.Me.CurrentTarget);
            if (RebornCoRoutine.WindowSettings.DontMoveIfMovinToYou &&
                !(RebornCoRoutine.WindowSettings.Dodge && Target.ShouldDodgeAway(Core.Me.CurrentTarget))
                && Core.Me.Distance(Core.Me.CurrentTarget.Location) < Core.Me.Distance(OldTargetLocation) && !MovementManager.IsMoving)
                return false;
            if (Core.Me.CurrentTarget != null && Core.Me.CurrentTarget.IsBehind && !Target.ShouldDodgeAway(Core.Me.CurrentTarget)
                && (!Core.Me.CurrentTarget.InLineOfSight() || !IsInSafeRange(Core.Me.CurrentTarget)
               // || MovementManager.IsMoving && !IsFacingMovement(Core.Me, Core.Me.CurrentTarget)
                ))
            {
                //if ((Core.Me.CurrentTarget.InLineOfSight() && IsFacingMovement(Core.Me, Core.Me.CurrentTarget)) && MovementManager.IsMoving) return false;//fatebot fix
                var mr = await Coroutine.ExternalTask(Task.Run(() => MoveTo(Core.Me.CurrentTarget)));
                if (mr == MoveResult.PathGenerationFailed) Logging.Write(Colors.Red, "[RebornCo] Path Generation Failed!!!");
                return false;
            }
            if (RebornCoRoutine.WindowSettings.Dodge && Target.ShouldDodgeBehind(Core.Me.CurrentTarget)
                && IsInSafeRange(Core.Me.CurrentTarget)&&IsFacing(Core.Me.CurrentTarget,Core.Me))
                    await WaitRunBehindTarget(Core.Me.CurrentTarget);
            if (Core.Me.CurrentTarget!=null 
                &&(!Core.Me.CurrentTarget.InLineOfSight() || !IsInSafeRange(Core.Me.CurrentTarget))
                //|| MovementManager.IsMoving && !IsFacingMovement(Core.Me, Core.Me.CurrentTarget)
                )
            {
                var mr = await Coroutine.ExternalTask(Task.Run(() => MoveTo(Core.Me.CurrentTarget)));
                if (mr == MoveResult.PathGenerationFailed) Logging.Write(Colors.Red, "[RebornCo] Path Generation Failed!!!");
                return false;
            }
            return false;
        }

        public static async Task<bool> WaitRunBehindTarget(GameObject c)
        {
            await Coroutine.ExternalTask(Task.Run(() => RunBehindTarget(c)));
            if (IsInSafeRange(c)) await Coroutine.Wait(3000, () => !TooClose(c) && !IsFacing(Core.Me, c) || !IsInSafeRange(c) || !MovementManager.IsMoving);
            if (!TooClose(c) && !IsFacing(Core.Me, c) || c.Distance() > CombatMovementRange(c)) StopMove();
            //if (m.Equals(MoveResult.PathGenerationFailed)) Logging.Write(Colors.OrangeRed, "[RebornCo] PathGenerationFailed");
            return false;
        }
        //Navigator.NavigationProvider.CanFullyNavigateTo()
        //Strafing
        private static MoveResult RunBehindTarget(GameObject c)
        {
            if (c == null) return MoveResult.Failed;
            if (Core.Me.Distance(MathEx.GetPointAt(c.Location, MeleeRange, MathEx.NormalizeRadian(c.Heading + (float)Math.PI))) > 1f)
            {
                Logging.Write(Colors.OrangeRed, "[RebornCo] Running Behind Target");
                Navigator.PlayerMover.MoveTowards(MathEx.GetPointAt(c.Location, MeleeRange, MathEx.NormalizeRadian(c.Heading + (float)Math.PI)));
                return MoveResult.Moving;
                //return Navigator.NavigationProvider.MoveToRandomSpotWithin( MathEx.GetPointAt(c.Location, MeleeRange, MathEx.NormalizeRadian(c.Heading + (float)Math.PI)), 1);
            }
             return MoveResult.ReachedDestination;
        }
        public static MoveResult MoveBehind(GameObject c)
        {
            if (Core.Me.IsCasting || c == null || !RebornCoRoutine.WindowSettings.Movement || Core.Me.IsMounted) return MoveResult.Failed;
            //if (IsTargetMoving) return MoveToTarget(GameObject c);
           return Navigator.NavigationProvider.MoveToRandomSpotWithin(
                MathEx.GetPointAt(c.Location, MeleeRange/2, MathEx.NormalizeRadian(c.Heading + (float)Math.PI)), 1);
             
        }
        public static async Task<bool> WaitMoveToTarget(GameObject c)
        {
            MoveResult mr = await Coroutine.ExternalTask(Task.Run(() => MoveTo(Core.Me.CurrentTarget)));
            if (mr == MoveResult.Moving || mr == MoveResult.GeneratingPath || mr == MoveResult.PathGenerated) await Coroutine.Wait(2000, () =>
                      mr == MoveResult.Moved || mr == MoveResult.Done || mr == MoveResult.Failed || mr == MoveResult.Failure || mr == MoveResult.ReachedDestination || mr == MoveResult.PathGenerationFailed);
            return false;
        }
        public static MoveResult MoveTo(GameObject o)
        {//Math.Abs(o.Z - Core.Me.Z) > 1 ?
            //MovementManager.IsMoving && Movement.IsFacingMovement(Core.Me, o)
            if (o == null) return MoveResult.Failed;
            if (!o.InLineOfSight() || Running || !RebornCoRoutine.WindowSettings.MeshFreeMovement) return Navigator.MoveTo(o.Location);
            Navigator.PlayerMover.MoveTowards(MathEx.GetPointAt(o.Location, CombatMovementRange(o), MathEx.NormalizeRadian(MathHelper.CalculateHeading(Core.Me.Location, Core.Me.CurrentTarget.Location))));
            return MoveResult.Moving;
            //return !o.InLineOfSight() ? Navigator.MoveTo(o.Location) : Navigator.NavigationProvider.MoveToRandomSpotWithin(MathEx.GetPointAt(o.Location, CombatMovementRange(o), MathEx.NormalizeRadian(MathHelper.CalculateHeading(Core.Me.Location, Core.Me.CurrentTarget.Location))), 1f);
        }
        #endregion
        public static async Task<bool> CombatCompanion()
        {
            if (RebornCoRoutine.WindowSettings.CombatChocobo && !Chocobo.Summoned && Chocobo.CanSummon)
            {
                if (MovementManager.IsMoving) await Coroutine.ExternalTask(Task.Run<bool>(() => StopMove()));
                return await Coroutine.ExternalTask(Task.Run<bool>(() => SummonChocobo()));
            }
            return false;
        }
        private static bool SummonChocobo()
        {
            Chocobo.Summon();
            return false;
        }
    }
}