﻿//////////////////////////////////////////////////
//                 Target.cs                    //
//         Part of RebornCo by kaihaider        //
//////////////////////////////////////////////////
using System.Collections.Generic; 
using System.Threading.Tasks;
using System.Windows.Media;
using ff14bot;
using ff14bot.Helpers;
using ff14bot.Managers;
using ff14bot.Objects;
using System.Linq;
namespace RebornCo.Helpers
{
    public class Target
    {
        public static uint[] SpellsBehindNarrow = { 569 };
        public static uint[] SpellsFrontalNarrow = { 317, 325, 334, 345, 399,446, 448, 495, 
            505, 545, 566, 568, 580, 589, 604, 618, 692, 720, 865, 866, 909, 914, 924, 937, 974, 1135 };
        public static uint[] SpellsFrontalWide = { 331, 506, 604, 606 };
        public static uint[] SpellsAoeTarget = {562, 738, 978};
        public static uint[] SpellsAoeUnit = { 441, 547, 1003 };
        public static bool ShouldDodgeBehind(GameObject o)
        {
            return RebornCoRoutine.WindowSettings.Dodge && (Core.Me.CurrentTarget as Character) != null && (Core.Me.CurrentTarget as Character).IsCasting 
                && ShouldDodgeBehind((Core.Me.CurrentTarget as Character).SpellCastInfo.ActionId);
        }
        public static bool ShouldDodgeBehind(uint spell)
        {
            return SpellsFrontalNarrow.Contains(spell) || SpellsFrontalWide.Contains(spell);
        }
        public static bool ShouldDodgeAway(GameObject o)
        {
            return RebornCoRoutine.WindowSettings.Dodge && (Core.Me.CurrentTarget as Character) != null && (Core.Me.CurrentTarget as Character).IsCasting
                && ShouldDodgeAway((Core.Me.CurrentTarget as Character).SpellCastInfo.ActionId);
        }
        public static bool ShouldDodgeAway(uint spell)
        {
            return SpellsAoeTarget.Contains(spell) || SpellsAoeUnit.Contains(spell);
        }
        static public IEnumerable<BattleCharacter> mNearbyEnemyUnits
        {
            get
            {
                if (!RebornCoRoutine.WindowSettings.Targeting && !RebornCoRoutine.WindowSettings.Aoe) return null;
                return GameObjectManager.GetObjectsOfType<BattleCharacter>(true, false)
                .Where(unit => !IsAboveTheGround(unit) //&& unit.IsVisible 
                     && unit.Distance(Core.Me) <= 40 && unit.CanAttack && unit.IsTargetable
                    && !unit.IsDead)
                        .OrderBy(unit => unit.Distance()).ToList();
            }
        }

        static public IEnumerable<BattleCharacter> mHostileUnits
        {
            get
            {
                if (!RebornCoRoutine.WindowSettings.Targeting && !RebornCoRoutine.WindowSettings.Aoe) return null;
                return GameObjectManager.GetObjectsOfType<BattleCharacter>(true, false)
                    .Where(unit => !IsAboveTheGround(unit)
                        && (unit.CurrentTargetId == Core.Me.ObjectId
                        //|| unit.IsTargetingMyPartyMember || unit.IsPlayer
                       //|| unit.ObjectId == botBasePoi || unit.ObjectId == botBaseUnit || unit.ObjectId == botBaseEntity 
                        || unit.TaggerObjectId == Core.Me.ObjectId)
                        && unit.CanAttack && unit.IsTargetable && !unit.IsDead && unit.Distance() <= 40 )
                       
                            .OrderBy(unit => unit.Distance()).ToList();
            }
        }
        // static public List<uint> mBlacklist { get; private set; }
        /*
        static public uint botBaseEntity { get; private set; }
        static public uint botBaseUnit { get; private set; }
        static public uint botBasePoi { get; private set; }
        static public void Pulse()
        {
            var tar = CombatTargeting.Instance;
            if (tar != null)
            {
                var poi = Poi.Current;
                BattleCharacter entity = tar.FirstEntity;
                BattleCharacter unit = tar.FirstUnit;
                BattleCharacter poiCharacter = poi.BattleCharacter;
                if (entity != null)
                    botBaseEntity= entity.ObjectId;
                if(tar.FirstUnit !=null)
                    botBaseUnit= unit.ObjectId;
                if (poiCharacter != null)
                    botBasePoi = poiCharacter.ObjectId;
            }
        }        */

        public static bool IsPoiTarget(GameObject u)
        {
            if (u == null) return false;
            return Poi.Current.Unit!=null && u.ObjectId == Poi.Current.Unit.ObjectId || Poi.Current.BattleCharacter!=null && u.ObjectId == Poi.Current.BattleCharacter.ObjectId;
        }
        static public bool aoeSafe { get; private set; } //to implement
        static public int EnemiesNearTarget(float range)
        {
            var target = Core.Player.CurrentTarget;
            if (target == null)
                return 0;
            var tarLoc = target.Location;
            if (mNearbyEnemyUnits == null) return 0;
            return mNearbyEnemyUnits.Count(u => u.ObjectId != target.ObjectId && u.Location.Distance3D(tarLoc) <= range);
        }
        public static bool IsAboveTheGround(GameObject u)
        {
            float height = u.Z - Core.Me.Z;
            if (height > System.Math.Max(Core.Me.CombatReach - 0.1f + u.CombatReach, 2.5f))
                return true;
            return false;
        }
        static public bool IsCurTargetSpecial()
        {
            // will implement
            return false;
        }

        public static async Task<bool> EnsureValidTarget()
        {
            if (Core.Me.CurrentTarget as Character != null)
            {
                if ((Core.Me.CurrentTarget as Character).IsDead)
                {
                    Logging.Write(Colors.OrangeRed, "[RebornCo] Target Dead, Clearing Target");
                    Movement.StopMove();
                    if(Core.Me.IsCasting)
                        await Buddy.Coroutines.Coroutine.ExternalTask(Task.Run(() => Actionmanager.StopCasting()));
                    if (RebornCoRoutine.WindowSettings.Targeting)
                     return await Buddy.Coroutines.Coroutine.ExternalTask(Task.Run<bool>(() => GetNewTarget()));
                }

            }
            if (!RebornCoRoutine.WindowSettings.Targeting) return false;
                 //Core.Me.CurrentTarget != null && ( Core.Me.CurrentTarget.ObjectId == botBaseEntity
                 //|| Core.Me.CurrentTarget.ObjectId == botBaseUnit || Core.Me.CurrentTarget.ObjectId == botBasePoi) && 
            if ((Core.Me.CurrentTarget as Character) == null
                 || Core.Me.CurrentHealthPercent < 60 && mNearbyEnemyUnits != null
                 && mHostileUnits.Count(unit => unit.Distance() <= 10) > 0 && Core.Me.CurrentTarget.Distance() > 25
                 || Core.Me.CurrentHealthPercent > 60 && Core.Me.CurrentTarget.Distance(Core.Me) > 30
                 && (Core.Me.CurrentTarget as Character).CurrentTargetId != Core.Me.ObjectId
                 && IsAboveTheGround(Core.Me.CurrentTarget)
                 || !Core.Me.CurrentTarget.CanAttack || (Core.Me.CurrentTarget as Character).IsDead)
                    await Buddy.Coroutines.Coroutine.ExternalTask(Task.Run<bool>(() => GetNewTarget()));
            return false;
        }
        /*
        protected Composite StopCastingDead
        {
            get
            {
                return
                    new Decorator(
                        r =>
                            Core.Player.SpellCastInfo != null &&
                            Core.Player.SpellCastInfo.TargetId != GameObjectManager.EmptyGameObject,
                        new PrioritySelector(
                            r => GameObjectManager.GetObjectByObjectId(Core.Player.SpellCastInfo.TargetId),
                            new Decorator(r => (r as Character) != null && (r as Character).IsDead,
                                new PrioritySelector(
                                    new FailLogger(
                                        r =>
                                            string.Format("Stop casting at {0} because it is dead.",
                                                (r as GameObject).Name)),
                                    new Action(r => Actionmanager.StopCasting()))
                                )));
            }
        }*/
        static private bool GetNewTarget()
        {
            Logging.Write(Colors.OrangeRed, "[RebornCo] Looking for NewTarget");
            if (mHostileUnits == null) return false;
            var nextUnit = mHostileUnits.FirstOrDefault();
            if (nextUnit != null)
            {
                Logging.Write(Colors.OrangeRed, "[RebornCo] Changing target to " + nextUnit.Name);
                Poi.Current = new Poi(nextUnit, PoiType.Kill);
                //nextUnit.Target();
            }
            else
            {
                if (mNearbyEnemyUnits == null) return false;
                nextUnit = mNearbyEnemyUnits.FirstOrDefault();
                if (nextUnit != null)
                {
                    Logging.Write(Colors.OrangeRed, "[RebornCo] Changing target to " + nextUnit.Name);
                    Poi.Current = new Poi(nextUnit, PoiType.Kill);
                }
                else  if (Core.Me.HasTarget)
                {
                    //Core.Me.ClearTarget();
                    Poi.Clear("[Reborn] Invaild");
                    Logging.Write(Colors.OrangeRed, "[RebornCo] Clearing Target");
                } 
            }
            return false;
        }
    }
}