﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Media;
using Buddy.Coroutines;
using ff14bot;
using ff14bot.Behavior;
using ff14bot.Enums;
using ff14bot.Helpers;
using ff14bot.Managers;
using ff14bot.Objects;
using RebornCo;
using RebornCo.Settings;
using RebornCo.Helpers;
using TreeSharp;

namespace RebornCo.Rotations
{
    public partial class Routines
    {
        [Behavior(BehaviorType.PreCombatBuffs, ClassJobType.Monk)]
        public Composite MonkCreateBasicPreCombatBuffs()
        {
            return new ActionRunCoroutine(ctx => MonkBuildPreCombatBuffs());
        }
        public static async Task<bool> MonkBuildPreCombatBuffs()
        {
            if (Core.Me.IsMounted) return false;
            await Spell.Cast("Protect", Core.Me, !Core.Me.HasAura("Protect"),false,false,true);
            await Spell.Cast("Foresight", Core.Me, !Core.Me.HasAura("Foresight"), false, false, true);
            return await Movement.CombatCompanion();
        }

        [Behavior(BehaviorType.Rest, ClassJobType.Monk)]
        public Composite MonkCreateBasicRest()
        {//check hidden remove
            return new ActionRunCoroutine(ctx => DefaultRestBehavior(Core.Player.CurrentTPPercent)); 
        }


        [Behavior(BehaviorType.CombatBuffs, ClassJobType.Monk)]
        public Composite MonkCreateBasicCombatBuffs()
        {
            return new ActionRunCoroutine(ctx => MonkBuildCombatBuffs()); 
        }
        public static async Task<bool> MonkBuildCombatBuffs()
        {//add fists of wind
            if (await Spell.Cast("Fists Of Fire", Core.Me, (Core.Me.CurrentHealth > 30 || !Core.Me.HasAura("Fists Of Earth"))
                && !Core.Me.HasAura("Fists Of Fire"))) return true;
            if (await Spell.Cast("Fists Of Earth", Core.Me, (Core.Me.CurrentHealth < 30 || !Core.Me.HasAura("Fists Of Fire"))
                && !Core.Me.HasAura("Fists Of Earth"))) return true;
            await Spell.Cast("Invigorate", Core.Me, Core.Me.CurrentTPPercent < 50,false,false,true);
            await Spell.Cast("Blood For Blood", Core.Me,true,false,false,true);
            await Spell.Cast("Bloodbath", Core.Me,true,false,false,true);
            await Spell.Cast("Raging Strikes", Core.Me,true,false,false,true);
            await Spell.Cast("Internal Release", Core.Me,true,false,false,true);
            await Spell.Cast("Keen Flurry", Core.Me, Core.Me.CurrentHealthPercent < 80,false,false,true);
            await Spell.Cast("Foresight", Core.Me, Core.Me.CurrentHealthPercent < 60,false,false,true);
            await Spell.Cast("Convalescence", Core.Me, Core.Me.CurrentHealthPercent < 70,false,false,true);
            await Spell.Cast("Cure", Core.Me, Core.Me.CurrentHealthPercent < 40,false,false,true);
            await Spell.Cast("Physick", Core.Me, Core.Me.CurrentHealthPercent < 40,false,false,true);
            await Spell.Cast("Second Wind", Core.Me, Core.Me.CurrentHealthPercent < 40,false,false,true);
            await Spell.Cast("Awareness", Core.Me, Core.Me.CurrentHealthPercent < 30, false, false, true);
            await Spell.Cast("Featherfoot", Core.Me, Core.Me.Distance2D() < 5, false, false, true);
            return false;
        }


        [Behavior(BehaviorType.Pull, ClassJobType.Monk)]
        public Composite MonkCreateBasicPull()
        {
            return new ActionRunCoroutine(ctx => MonkBuildPullBehavior()); 
        }
        public static async Task<bool> MonkBuildPullBehavior()
        {
            await Target.EnsureValidTarget();
            if (Core.Me.HasAura("Raptor Form"))
            {
                if (await Spell.PullCast("Twin Snakes", Core.Me.CurrentTarget, Core.Me.CurrentTarget != null && Core.Me.CurrentTarget.IsBehind
                    || !Core.Me.HasAura("Twin Snakes"))) return true;
                if (await Spell.PullCast("True Strike", Core.Me.CurrentTarget)) return true;
            }
            if (Core.Me.HasAura("Coeurl Form"))
            {
                if (await Spell.PullCast("Demolish", Core.Me.CurrentTarget, Core.Me.CurrentTarget != null && 
                            !Core.Me.CurrentTarget.HasAura("Demolish",true))) return true; //
                if (await Spell.PullCast("Snap Punch", Core.Me.CurrentTarget, Core.Me.CurrentTarget != null && Core.Me.CurrentTarget.IsFlanking))
                    return true;
                if (await Spell.PullCast("Demolish", Core.Me.CurrentTarget)) return true;
                if (await Spell.PullCast("Snap Punch", Core.Me.CurrentTarget)) return true;
            }
            return await Spell.PullCast("Bootshine", Core.Me.CurrentTarget);
            // return false;
        }

        [Behavior(BehaviorType.Combat, ClassJobType.Monk)]
        public Composite MonkCreateBasicCombat()
        {
            return new ActionRunCoroutine(ctx => MonkBuildBasicCombat()); 
        }
        public static async Task<bool> MonkBuildBasicCombat()
        {//intterupt Arm of the Destroyer in Opo-opoform

            await Target.EnsureValidTarget();
            await Movement.MoveToTarget();
            if (PugSettings == null)
            {
                Logging.Write(Colors.OrangeRed, "Error in Settings");
                return false;
            }
            Gcd = await Coroutine.ExternalTask(Task.Run(() => Spell.PugGcd()));
            if (!Gcd && await Spell.CastLock("Touch of Death", Core.Me.CurrentTarget, Core.Me.CurrentTarget != null
                && Core.Me.CurrentTarget.CurrentHealthPercent > PugSettings.MinDotHp
                       && !Core.Me.CurrentTarget.HasAura("Touch of Death", true, PugSettings.TouchOfDeathClip))) return true;
            if (!Gcd && await Spell.Cast("Perfect Balance", Core.Me, PugSettings.CooldownsUsable && !Core.Me.HasAura("Perfect Balance")))
                return true;
            if (!Gcd && Core.Me.HasAura("Perfect Balance"))
            {//possible rockbreaker
                if (await Spell.CastLock("Demolish", Core.Me.CurrentTarget, Core.Me.CurrentTarget != null 
                       && !Core.Me.CurrentTarget.HasAura("Demolish",true,PugSettings.DemolishClip))) return true;
                if (await Spell.CastLock("Twin Snakes", Core.Me.CurrentTarget, !Core.Me.HasAura("Twin Snakes", false, PugSettings.TwinSnakesClip))) return true;
                if (await Spell.CastLock("Snap Punch", Core.Me.CurrentTarget)) return true;
            }
            if (!Gcd && await Spell.CastLock("Virus", Core.Me.CurrentTarget, Core.Me.CurrentTarget != null && (Core.Me.CurrentTarget as Character) != null &&
                        !(Core.Me.CurrentTarget as Character).HasAura("Virus"))) return true; //
            if (await Spell.Cast("Mercy Stroke", Core.Me.CurrentTarget)) return true;
            if (!Gcd && await Spell.Cast("Steel Peak", Core.Me.CurrentTarget)) return true;
            if (!Gcd && await Spell.Cast("Howling Fist", Core.Me.CurrentTarget, Core.Me.CurrentTarget != null && Core.Me.CurrentTarget.CurrentHealthPercent > PugSettings.MinDotHp
                && Core.Me.CurrentTarget.Distance() > Movement.MeleeRange + 3 && Core.Me.CurrentTarget.Distance() < 10f)) return true; //range
            if (!Gcd && await Spell.CastLock("Venomous Bite", Core.Me.CurrentTarget, Core.Me.CurrentTarget != null
                        && !Core.Me.CurrentTarget.HasAura("Venomous Bite",true))) return true;
            if (!Gcd && await Spell.CastLock("Fracture", Core.Me.CurrentTarget, Core.Me.CurrentTarget != null && (Core.Me.CurrentTarget as Character) != null
                        && !(Core.Me.CurrentTarget as Character).HasAura("Fracture"))) return true;
            if (!Gcd && Core.Me.HasAura("Raptor Form"))
            {//One Ilm Punch - check if target has buff to remove
                if (await Spell.CastLock("Twin Snakes", Core.Me.CurrentTarget, //Core.Me.CurrentTarget != null && Core.Me.CurrentTarget.IsBehind || 
                    !Core.Me.HasAura("Twin Snakes", false, PugSettings.TwinSnakesClip))) return true;
                if (await Spell.CastLock("True Strike", Core.Me.CurrentTarget)) return true;
            }
            if (!Gcd && Core.Me.HasAura("Coeurl Form"))
            {
                if (Core.Me.CurrentTarget != null && await Spell.Cast("Rockbreaker", Core.Me.CurrentTarget,
                            Core.Me.CurrentTarget.Distance() < 5 && PugSettings.Aoe && Target.EnemiesNearTarget((float)2.5) >= WindowSettings.AoeCount)) return true;
                if (await Spell.CastLock("Snap Punch", Core.Me.CurrentTarget, Core.Me.CurrentTarget != null && Core.Me.CurrentTarget.IsFlanking)) return true;
                if (await Spell.CastLock("Demolish", Core.Me.CurrentTarget, !Core.Me.CurrentTarget.HasAura("Demolish", true, PugSettings.DemolishClip))) return true; //
                //if (await Spell.CastLock("Demolish", Core.Me.CurrentTarget)) return true;
                if (Core.Me.CurrentTarget != null && await Spell.Cast("Rockbreaker", Core.Me.CurrentTarget,Core.Me.CurrentTarget.Distance() < 5)) return true;
                if (await Spell.CastLock("Snap Punch", Core.Me.CurrentTarget)) return true;
            }
            if (!Gcd && Core.Me.HasAura("Opo-opo Form"))
            {
                if (await Spell.CastLock("Dragon Kick", Core.Me.CurrentTarget, !Core.Me.CurrentTarget.HasAura("Dragon Kick", true))) return true;
            }
            // if (await Spell.CastLock("Dragon Kick", Core.Me.CurrentTarget, Core.Me.CurrentTarget != null && Core.Me.CurrentTarget.IsFlanking)) return true;
            if (!Gcd) await Spell.Cast("Haymaker", Core.Me.CurrentTarget, true, false, false, true);
            if (!Gcd && await Spell.CastLock("Bootshine", Core.Me.CurrentTarget, !(Core.Me.HasAura("Raptor Form") || Core.Me.HasAura("Coeurl Form") || Core.Me.HasAura("Perfect Balance")))) return true;
            return false;
        }

    }
}
