﻿//////////////////////////////////////////////////
//              ArcanistSettings.cs             //
//         Part of RebornCo by kaihaider        //
//////////////////////////////////////////////////
using System.ComponentModel;
using System.Configuration;
using System.IO;
using System.Windows.Media;
using ff14bot.Helpers;
using Newtonsoft.Json;

namespace RebornCo.Settings
{
    public class RogueSetting : JsonSettings, ICore
    {
        [JsonIgnore]
// ReSharper disable once InconsistentNaming
        public static RogueSetting _instance;

        public static RogueSetting Instance
        {
            get
            {
                if (_instance != null) return _instance;
                Logging.Write(Colors.Red, "(RebornCo) Why you null T_T");
                _instance = new RogueSetting();
                Logging.Write(Colors.Red, "(RebornCo) Tell me T_T");
                return _instance;
            }
        }

        public RogueSetting(string filename = "RebornCoSettingsRogue")
            : base(Path.Combine(CharacterSettingsDirectory, filename + ".json"))
        {
        }

        [Setting]
        [DefaultValue(true)]
        [Category("Rogue")]
        public bool SneakAttack { get; set; }

        [Setting]
        [DefaultValue(true)]
        [Category("Rogue")]
        public bool UseHide { get; set; }

        [Setting]
        [DefaultValue(6000)]
        [Category("Rogue")]
        public int DancingEdgeClip { get; set; }

        [Setting]
        [DefaultValue(6000)]
        [Category("Rogue")]
        public int ShadowFangClip { get; set; }

        [Setting]
        [DefaultValue(6000)]
        [Category("Rogue")]
        public int MutilationClip { get; set; }

        #region general
        [Setting]
        [DefaultValue(true)]
        [Category("General")]
        public bool Debug { get; set; }

        [Setting]
        [DefaultValue(true)]
        [Category("General")]
        public bool MeshFreeMovement { get; set; }

        [Setting]
        [DefaultValue(true)]
        [Category("General")]
        public bool Combat { get; set; }

        [Setting]
        [DefaultValue(false)]
        [Category("General")]
        public bool Targeting { get; set; }

        [Setting]
        [DefaultValue(true)]
        [Category("General")]
        public bool Movement { get; set; }

        [Setting]
        [DefaultValue(false)]
        [Category("General")]
        public bool DontMoveIfMovinToYou { get; set; }

        [Setting]
        [DefaultValue(40f)]
        [Category("General")]
        public float RestHealth { get; set; }

        [Setting]
        [DefaultValue(40f)]
        [Category("General")]
        public float RestEnergy { get; set; }

        [Setting]
        [DefaultValue(false)]
        [Category("General")]
        public bool CombatChocobo { get; set; }

        [Setting]
        [Category("General")]
        [DefaultValue(CooldownUse.Always)]
        public CooldownUse Cooldowns { get; set; }

        [Setting]
        [Category("General")]
        [DefaultValue(false)]
        public bool Aoe { get; set; }

        [Setting]
        [DefaultValue(400)]
        [Category("Core")]
        public int GcdSyncWait { get; set; }

        [Setting]
        [DefaultValue(800)]
        [Category("Core")]
        public int SpellQueueWindow { get; set; }

        [Setting]
        [DefaultValue(3f)]
        [Category("General")]
        public float AoeCount { get; set; }

        [Setting]
        [DefaultValue(true)]
        [Category("General")]
        public bool Dodge { get; set; }

        [Setting]
        [DefaultValue(15f)]
        [Category("General")]
        public float MinDotHp { get; set; }

        [Browsable(false)]
        public virtual float RestEnergyDone
        {
            get
            {
                if (RestEnergy * 2 < 100)
                    return RestEnergy * 2;
                return 100f;
            }
        }

        [Browsable(false)]
        public virtual float RestHealthDone
        {
            get
            {
                if (RestHealth * 2 < 100)
                    return RestHealth * 2;
                return 100f;
            }
        }

        [Browsable(false)]
        public virtual bool CooldownsUsable
        {

            get
            {
                if (RebornCoRoutine.WindowSettings as RogueSetting == null) return false;
                switch ((RebornCoRoutine.WindowSettings as RogueSetting).Cooldowns)
                {
                    case CooldownUse.Always:
                        return true;
                    /* 
                case CooldownUse.BySpecial:
                    return Target.IsCurTargetSpecial();
case CooldownUse.ByFocus:
                   return Helpers.RebornCoHelp.me.FocusedUnit != null && Helpers.RebornCoHelp.me.FocusedUnit.Guid == Helpers.RebornCoHelp.me.CurrentTarget.Guid &&
                          !Helpers.RebornCoHelp.me.FocusedUnit.IsFriendly;
                   */
                }
                return false;
            }
        }
        #endregion
    }

}